import Modifier from 'ember-modifier';
import { EQInfo, ModifierArgs, Sizes } from 'ember-element-query';
export interface SizeObject {
    name: string;
    value: number;
    index: number;
}
export declare type RangeDirection = 'at' | 'from' | 'to';
interface ResizeObserverService {
    observe(element: HTMLElement, callback?: () => void): void;
    unobserve(element: HTMLElement, callback?: () => void): void;
    isEnabled: boolean;
}
/** @internal */
export default class ElementQueryModifier extends Modifier<ModifierArgs> {
    resizeObserver: ResizeObserverService;
    sizesDefault: Sizes;
    sizesHeightDefault: Sizes;
    sizesRatioDefault: Sizes;
    _element?: HTMLElement;
    _firstCall: boolean;
    get width(): number;
    get height(): number;
    get debounce(): number;
    get ratio(): number;
    get sizes(): Sizes | undefined;
    get sizesHeight(): Sizes | undefined;
    get sizesRatio(): Sizes | undefined;
    get sizeObjectsWidthSortedAsc(): SizeObject[] | undefined;
    get sizeObjectsHeightSortedAsc(): SizeObject[] | undefined;
    get sizeObjectsRatioSortedAsc(): SizeObject[] | undefined;
    get sizeObjectWidthAt(): SizeObject | undefined;
    get sizeObjectHeightAt(): SizeObject | undefined;
    get sizeObjectRatioAt(): SizeObject | undefined;
    get sizeObjectsWidthFrom(): SizeObject[] | undefined;
    get sizeObjectsHeightFrom(): SizeObject[] | undefined;
    get sizeObjectsRatioFrom(): SizeObject[] | undefined;
    get sizeObjectsWidthTo(): SizeObject[] | undefined;
    get sizeObjectsHeightTo(): SizeObject[] | undefined;
    get sizeObjectsRatioTo(): SizeObject[] | undefined;
    get attributesWidthAt(): string[];
    get attributesWidthFrom(): string[];
    get attributesWidthTo(): string[];
    get attributesWidth(): string[];
    get attributesHeightAt(): string[];
    get attributesHeightFrom(): string[];
    get attributesHeightTo(): string[];
    get attributesHeight(): string[];
    get attributesRatioAt(): string[];
    get attributesRatioFrom(): string[];
    get attributesRatioTo(): string[];
    get attributesRatio(): string[];
    get attributes(): string[];
    get attributesRecord(): Record<string, true>;
    get attributesWidthAtRetired(): string[];
    get attributesWidthFromRetired(): string[];
    get attributesWidthToRetired(): string[];
    get attributesWidthRetired(): string[];
    get attributesHeightAtRetired(): string[];
    get attributesHeightFromRetired(): string[];
    get attributesHeightToRetired(): string[];
    get attributesHeightRetired(): string[];
    get attributesRatioAtRetired(): string[];
    get attributesRatioFromRetired(): string[];
    get attributesRatioToRetired(): string[];
    get attributesRatioRetired(): string[];
    get attributesRetired(): string[];
    get yield(): EQInfo;
    convertSizeToAttribute(size: string, rangeDirection: RangeDirection): string;
    applyAttributesToElement(): void;
    callOnResize(): void;
    buildSizeObjectsSortedAsc(sizes: Sizes): SizeObject[];
    findSizeObjectAt(sizeObjectsSortedAsc: SizeObject[], dimension: number): SizeObject;
    _didResizeHandlerSync(): void;
    _didResizeHandlerRequestAnimationFrame(): void;
    didResizeHandler(): void;
    didInstall(): void;
    didUpdateArguments(): void;
    willRemove(): void;
}
export {};
